"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var healthcheckElasticsearch = function (_a) {
    var client = _a.client, testIndex = _a.testIndex;
    return __awaiter(void 0, void 0, void 0, function () {
        var oldTestvalue, r, err_1, updateResult, newTestvalue;
        var _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, client.search({
                            index: testIndex,
                            body: {
                                query: {
                                    match_all: {}
                                },
                            }
                        })];
                case 1:
                    r = _c.sent();
                    oldTestvalue = r.body.hits.hits[0]._source.testvalue;
                    return [3 /*break*/, 3];
                case 2:
                    err_1 = _c.sent();
                    // on first run the index is expected ot to exist
                    if (((_b = err_1.meta.body) === null || _b === void 0 ? void 0 : _b.error.type) === 'index_not_found_exception') {
                        oldTestvalue = 0;
                        console.log("Index not found: Assuming an initial test run and therefore a testvalue of " + oldTestvalue);
                    }
                    else {
                        throw new Error(err_1);
                    }
                    return [3 /*break*/, 3];
                case 3: return [4 /*yield*/, client.update({
                        index: testIndex,
                        id: '1',
                        _source: ['testvalue'],
                        body: {
                            // increment testvalue
                            script: {
                                source: "ctx._source.testvalue += 1"
                            },
                            // set testvalue to 1, if not exists
                            upsert: {
                                testvalue: 1
                            },
                        }
                    })];
                case 4:
                    updateResult = _c.sent();
                    newTestvalue = updateResult.body.get._source.testvalue;
                    return [2 /*return*/, {
                            name: healthcheckElasticsearch.name,
                            success: true,
                            data: {
                                oldValue: oldTestvalue,
                                newValue: newTestvalue,
                            },
                        }];
            }
        });
    });
};
exports.default = healthcheckElasticsearch;
